/*
* Copyright (c) 2023, ɽƼ޹˾
* All rights reserved.
*
* ļƣcandriver.c
* can
*/

#include "headfile.h"

uint8_t gucCANRecFlag = 1;
CanRxMsg CanRxStructure;
u8 rxbuf[8];
/*
 * ***********************************************************
**  void can_gpio_init(void)
**  can_gpioʼ (CAN1_TX PA12  CAN1_RX PA11)
** ڲ 
** ڲ 
**************************************************************
*/
void can_gpio_init(void)
{
    GPIO_InitTypeDef      GPIO_InitSturcture = {0};

    RCC_APB2PeriphClockCmd(RCC_APB2Periph_AFIO | RCC_APB2Periph_GPIOA, ENABLE);
    RCC_APB1PeriphClockCmd(RCC_APB1Periph_CAN1, ENABLE);

    GPIO_InitSturcture.GPIO_Pin = GPIO_Pin_12;
    GPIO_InitSturcture.GPIO_Mode = GPIO_Mode_AF_PP;             // ùܲ
    GPIO_InitSturcture.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_Init(GPIOA, &GPIO_InitSturcture);

    GPIO_InitSturcture.GPIO_Pin = GPIO_Pin_11;
    GPIO_InitSturcture.GPIO_Mode = GPIO_Mode_IPU;               // 
    GPIO_Init(GPIOA, &GPIO_InitSturcture);
}
void Can1_NVIC_Configeration(void)
{
    //CAN_ClearITPendingBit(CAN1, CAN_IT_FMP0);     //жϱ־λĺ

    NVIC_InitTypeDef      NVIC_InitStructure = {0};

    NVIC_InitStructure.NVIC_IRQChannel = USB_LP_CAN1_RX0_IRQn;
    NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 1;
    NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;
    NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
    NVIC_Init(&NVIC_InitStructure);

    CAN_ITConfig(CAN1, CAN_IT_FMP0, ENABLE);
}

//עжϲ
void USB_LP_CAN1_RX0_IRQHandler(void) __attribute__((interrupt("WCH-Interrupt-fast")));

//жϲ
void USB_LP_CAN1_RX0_IRQHandler(void)
{
    u8 rx;

    if(CAN_GetITStatus(CAN1, CAN_IT_FMP0) != RESET)
    {
        //CAN_ClearITPendingBit(CAN1, CAN_IT_FMP0);     //жϱ־λĺ
        rx = CAN_Receive_Msg(rxbuf);
        gucCANRecFlag = 1;

        if(rx)
        {
            Delay_Ms(1);
            Can_Send_Msg(rxbuf, rx);
        }
    }
}
/*
 * ***********************************************************
**  void SDA_IN(void)
**  i2cģʽ
** ڲ 
** ڲ 
**************************************************************
*/
void Can_mode_init(uint8_t tsjw, uint8_t tbs2, uint8_t tbs1, uint16_t brp, uint8_t mode)
{
    CAN_InitTypeDef       CAN_InitSturcture = {0};

    CAN_InitSturcture.CAN_TTCM = ENABLE;                            // ʱ䴥ͨģʽ  ENABLE
    CAN_InitSturcture.CAN_ABOM = DISABLE;                           // Զ߹
    CAN_InitSturcture.CAN_AWUM = DISABLE;                           // ˯ģʽͨ(CAN->MCRSLEEPλ)
    CAN_InitSturcture.CAN_NART = ENABLE;                            // ֹԶ  ENABLE
    CAN_InitSturcture.CAN_RFLM = DISABLE;                           // ĲµĸǾɵ
    CAN_InitSturcture.CAN_TXFP = DISABLE;                           // ȼɱıʶ
    CAN_InitSturcture.CAN_Mode = mode;                              // ػģʽ Է
    CAN_InitSturcture.CAN_SJW  = tsjw;                              // ͬԾ(tsjw)Ϊtsjw+1ʱ䵥λ CAN_SJW_1tq ~ CAN_SJW_4tq
    CAN_InitSturcture.CAN_BS1  = tbs1;                              // Tbs1ΧCAN_BS1_1tq ~ CAN_BS1_16tq
    CAN_InitSturcture.CAN_BS2  = tbs2;                              // Tbs1ΧCAN_BS1_1tq ~ CAN_BS1_8tq
    CAN_InitSturcture.CAN_Prescaler = brp;                          // Ƶϵ(Fdiv)Ϊbrp+1
    CAN_Init(CAN1, &CAN_InitSturcture);                             // ʼCAN1
}

/*
 * ***********************************************************
**  void Can_FilterInitSturcture_Init(void)
**  can˲ FIFO 0
** ڲ 
** ڲ 
**************************************************************
*/
void Can_FilterInitSturcture_Init(void)
{
    CAN_FilterInitTypeDef CAN_FilterInitSturcture = {0};

    /* identifier/mask mode, One 32-bit filter, ExtId: 0x12124567 */
    CAN_FilterInitSturcture.CAN_FilterNumber = 0;                           // 0
    CAN_FilterInitSturcture.CAN_FilterMode = CAN_FilterMode_IdMask;         // λģʽ
    CAN_FilterInitSturcture.CAN_FilterScale = CAN_FilterScale_32bit;        // 32λ
    CAN_FilterInitSturcture.CAN_FilterIdHigh = 0x0000;                      // 32λID        0x9092
    CAN_FilterInitSturcture.CAN_FilterIdLow = 0x0000;                       //               0x2B3C
    CAN_FilterInitSturcture.CAN_FilterMaskIdHigh = 0x0000;                  // 32λMASK      0xFFFF
    CAN_FilterInitSturcture.CAN_FilterMaskIdLow = 0x0000;                   //              0xFFFE
    CAN_FilterInitSturcture.CAN_FilterFIFOAssignment = CAN_Filter_FIFO0;    // 0FIFO0
    CAN_FilterInitSturcture.CAN_FilterActivation = ENABLE;                  // 0
    CAN_FilterInit(&CAN_FilterInitSturcture);                               // ˲ʼ
}
