/*
* Copyright (c) 2023, 山东铂金动力科技有限公司
* All rights reserved.
*
*  文件名称：headfile.h
*  功能描述：公共头文件包含
*/

#ifndef __HEADFILE_H
#define __HEADFILE_H

/* "CH32V203"库函数 */
#include "ch32v20x.h"
#include "debug.h"          // 串口初始化、delay延时
#include "string.h"
#include "stdio.h"

/* 驱动层 */
#include "can_driver.h"
#include "tim_driver.h"
#include "iap.h"
#include "flash.h"
#include "iap.h"

/* 应用层 */
#include "can_middle.h"

#endif
