/*
* Copyright (c) 2023, ɽƼ޹˾
* All rights reserved.
*
* ļƣcanmiddle.c
* canм
*/

#include "headfile.h"

u8 txbuf[8];
u8 tx;

uint8_t gucCanRxBuf[8];

/*
 * ***********************************************************
**  void Can_init(void)
**  canʼ
** ڲ 
** ڲ 
**************************************************************
*/
void Can_init(void)
{
    can_gpio_init();                                                                // can_GPIOʼ
    Can_mode_init(CAN_SJW_2tq, CAN_BS2_2tq, CAN_BS1_5tq, 9, CAN_Mode_Normal);       // canģʽʳʼ
    Can_FilterInitSturcture_Init();
    Can1_NVIC_Configeration();                                                      // can1ж
}

/*
 * ***********************************************************
**  uint8_t Can_Send_Msg(uint8_t* msg, uint8_t len)
**  canһݣ̶ʽIDΪ0x12 ׼֡ ֡
** ڲ uint8_t* msg:棬Ϊ8ֽ
**          uint8_t len: ݳȣΪ8
** ڲ ֵΪ0ɹ
**************************************************************
*/
uint8_t Can_Send_Msg(uint8_t* msg, uint8_t len)
{
    uint8_t mbox;
    uint16_t i = 0;
    CanTxMsg TxMessage;
    TxMessage.StdId = 0x12;                 // ׼ʶ
    TxMessage.ExtId = 0x12345678;           // չʾ
    TxMessage.IDE = CAN_Id_Extended;        // չ֡
    TxMessage.RTR = CAN_RTR_Data;           // ֡
    TxMessage.DLC = len;                    // Ҫ͵ݳ

    for(i = 0; i < len; i++)
    {
        TxMessage.Data[i] = msg[i];
    }
    mbox = CAN_Transmit(CAN1, &TxMessage);
    i = 0;
    while((CAN_TransmitStatus(CAN1, mbox) == CAN_TxStatus_Failed) && (i < 0XFFF))
    {
        i++;
    }
    if(i >= 0xFFF)
    {
        return 1;
    }
    return 0;
}

/*
 * ***********************************************************
**  uint8_t Can_Send_Msg(uint8_t* msg, uint8_t len)
**  canһݣ̶ʽIDΪ0x12 ׼֡ ֡
** ڲ uint8_t* msg:棬Ϊ8ֽ
**          uint8_t len: ݳȣΪ8
** ڲ ֵΪ0ɹ
**************************************************************
*/
void can_tx_frame_data(uint8_t data1, uint8_t data2)
{
    CanTxMsg TxMessage;

    TxMessage.StdId = 0x12;                 // ׼ʶ
    TxMessage.ExtId = 0x0012;               // չʾ
    TxMessage.IDE = CAN_Id_Extended;        // չ֡
    TxMessage.RTR = CAN_RTR_Data;           // ֡
    TxMessage.DLC = 2;                      // Ҫ͵ݳ
    TxMessage.Data[0] = data1;              // ͵1
    TxMessage.Data[1] = data2;              // ͵2

    CAN_Transmit(CAN1, &TxMessage);         // canݺ
}

/*
 * ***********************************************************
**  uint8_t Can_Reveive_Msg(uint8_t *buf)
**  canպ
** ڲ uint8_t *buf ݻ;
** ڲ RxMessage.DLC ֡ȣָҪյ֡ ֵΪ0ݱյ
**                                          ֵΪ:ʾܵݳ
**************************************************************
*/
uint8_t CAN_Receive_Msg(uint8_t *buf)
{
    uint8_t i;

    if(CAN_MessagePending(CAN1, CAN_FIFO0) == 0)
    {
        return 0;
    }

    CAN_Receive(CAN1, CAN_FIFO0, &CanRxStructure);

    for(i = 0; i < 8; i++)
    {
        buf[i] = CanRxStructure.Data[i];
    }

    return CanRxStructure.DLC;
}
